| The Gaudi Framework v29r1 (5cd95fa2)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Attributes | Friends | List of all members
SmartRef< TYPE > Class Template Reference

Kernel objects: SmartRef. More...

`#include <GaudiKernel/SmartRef.h>`

Collaboration diagram for SmartRef< TYPE >:
[legend]

## Public Types
enum | { VALID = StreamBuffer::VALID, INVALID = StreamBuffer::INVALID }
typedef TYPE | entry_type
| Entry type definition. More...

## Public Member Functions
| SmartRef ()
| Standard Constructor. More...
| SmartRef (TYPE *pObject)
| Standard Constructor with initialisation. More...
| SmartRef (const TYPE *pObject)
| Standard Constructor with initialisation from const object. More...
| SmartRef (const SmartRef &copy)
| Copy Constructor. More...
| SmartRef (long hint, long link, TYPE *obj=nullptr)
| Constructor. More...
| SmartRef (const ContainedObject *pObj, long hint, long link, TYPE *obj=nullptr)
| Constructor for references to contained objects passing environment. More...
| SmartRef (const DataObject *pObj, long hint, long link, TYPE *obj=nullptr)
| Constructor for references to contained objects passing environment. More...
| SmartRef (const DataObject *pObj, long hint, TYPE *obj=nullptr)
| Constructor for references to DataObjects passing environment. More...
bool | shouldFollowLink (const DataObject *) const
| Standard destructor. More...
bool | shouldFollowLink (const ContainedObject *) const
| Check if link should be followed: link must be valid and object not yet loaded. More...
long | hintID () const
| Access hint id: More...
long | linkID () const
| Access link id: More...
void | set (DataObject *pObj, long hint_id, long link_id)
| Setup smart reference when reading. Must be allowed from external sources. More...
const std::type_info * | type () const
| Access to embedded type. More...
TYPE * | data ()
| Access to raw data pointer. More...
const TYPE * | data () const
const TYPE * | target () const
| Access to the object. More...
TYPE * | target ()
| Access to the object. More...
const std::string & | path () const
| Return the path of the linked object inside the data store. More...
bool | operator== (const SmartRef< TYPE > &c) const
| Equality operator. More...
bool | operator!= (const SmartRef< TYPE > &c) const
| NON-Equality operator. More...
const SmartRef< TYPE > & | _setEnvironment (const DataObject *pObj, const ContainedObject *pContd) const
| Set the environment (CONST) More...
SmartRef< TYPE > & | _setEnvironment (const DataObject *pObj, const ContainedObject *pContd)
| Set the environment (CONST) More...
SmartRef< TYPE > & | operator() (ContainedObject *pObj)
| operator(): assigns parent object for serialisation More...
const SmartRef< TYPE > & | operator() (const ContainedObject *pObj) const
| operator() const: assigns parent object for serialisation More...
SmartRef< TYPE > & | operator() (DataObject *pObj)
| operator(): assigns parent object for serialisation More...
const SmartRef< TYPE > & | operator() (const DataObject *pObj) const
| operator() const: assigns parent object for serialisation More...
SmartRef< TYPE > & | operator= (const SmartRef< TYPE > &c)
| Assignment. More...
SmartRef< TYPE > & | operator= (TYPE *pObject)
| Assignment. More...
TYPE & | operator* ()
| Dereference operator. More...
const TYPE & | operator* () const
| Dereference operator. More...
TYPE * | operator-> ()
| Dereference operator. More...
const TYPE * | operator-> () const
| Dereference operator to const object. More...
| operator const TYPE * () const
| Implicit type conversion to const object. More...
| operator TYPE * ()
| Implicit type conversion. More...
StreamBuffer & | writeRef (StreamBuffer &s) const
| Write the reference to the stream buffer (needed due to stupid G++ compiler) More...
StreamBuffer & | readRef (StreamBuffer &s)
| Read the reference from the stream buffer (needed due to stupid G++ compiler) More...

## Protected Attributes
SmartRefBase | m_base
const TYPE * | m_target = nullptr
| Pointer to target data object. More...

## Friends
class | SmartRefArray< TYPE >
| The container must be a friend. More...
class | SmartRefList< TYPE >
class | SmartRefMap< TYPE >
StreamBuffer & | operator<< (StreamBuffer &_s, const SmartRef< TYPE > &ptr)
| Output Streamer operator. More...
StreamBuffer & | operator>> (StreamBuffer &_s, SmartRef< TYPE > &ptr)
| Input Streamer operator. More...

## Detailed Description

### template<class TYPE>
class SmartRef< TYPE >

Kernel objects: SmartRef.

Description: The SmartRef class allows transparent handling of object links within the data store. Links are unloaded a priori and will only be loaded "on demand", i.e. when dereferenced.

SmartRefs should behave in the same way as normal pointers; The SmartRef object in fact is a smart pointer construct intercepting the dereference operators.

When loading, the executed code resides in the non templated base class. This ensures, that the templated code is minimized and code blow up is inhibited.

Using SmartRefs StreamBuffers are able to also save the references on data conversion requests.

Base Class: SmartRefBase

Dependencies:

- Base class: GaudiKernel/SmartRefBase.h

History :

    +---------+----------------------------------------------+--------+
    |    Date |                 Comment                      | Who    |
    +---------+----------------------------------------------+--------+
    | 21/04/99| Initial version.                             | MF     |
    | 16/01/04| Move base class into aggregation.            | MF     |
    +---------+----------------------------------------------+--------+

Author: M.Frank Version: 1.0

Definition at line 66 of file SmartRef.h.

## Member Typedef Documentation

template<class TYPE>

typedef TYPE SmartRef< TYPE >::entry_type

Entry type definition.

Definition at line 76 of file SmartRef.h.

## Member Enumeration Documentation

template<class TYPE>

anonymous enum

Enumerator
VALID |
INVALID |

Definition at line 74 of file SmartRef.h.

74 { VALID = StreamBuffer::VALID, INVALID = StreamBuffer::INVALID };
SmartRef::VALID
Definition: SmartRef.h:74
StreamBuffer::VALID
Definition: StreamBuffer.h:119
StreamBuffer::INVALID
Definition: StreamBuffer.h:119
SmartRef::INVALID
Definition: SmartRef.h:74

## Constructor & Destructor Documentation

template<class TYPE>

SmartRef< TYPE >::SmartRef | ( |  | ) |
| inline

Standard Constructor.

Definition at line 85 of file SmartRef.h.

86 {
87 m_base.m_hintID = INVALID;
88 m_base.m_linkID = INVALID;
89 _setEnvironment( 0, 0 );
90 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
SmartRef::INVALID
Definition: SmartRef.h:74
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | TYPE * | pObject | ) |
| inline

Standard Constructor with initialisation.

Definition at line 92 of file SmartRef.h.

93 {
94 m_base.m_hintID = INVALID;
95 m_base.m_linkID = INVALID;
96 m_target = pObject;
97 _setEnvironment( 0, 0 );
98 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
SmartRef::INVALID
Definition: SmartRef.h:74
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const TYPE * | pObject | ) |
| inline

Standard Constructor with initialisation from const object.

Definition at line 100 of file SmartRef.h.

101 {
102 m_base.m_hintID = INVALID;
103 m_base.m_linkID = INVALID;
104 m_target = const_cast<TYPE*>( pObject );
105 _setEnvironment( 0, 0 );
106 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
SmartRef::INVALID
Definition: SmartRef.h:74
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const SmartRef< TYPE > & | copy | ) |
| inline

Copy Constructor.

Definition at line 108 of file SmartRef.h.

109 {
110 m_base.m_hintID = copy.m_base.m_hintID;
111 m_base.m_linkID = copy.m_base.m_linkID;
112 m_target = copy.m_target;
113 _setEnvironment( copy.m_base.m_data, copy.m_base.m_contd );
114 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:55
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:57
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | long | hint,
|  | long | link,
|  | TYPE * | obj = `nullptr`
| ) |  |
| inline

Constructor.

Definition at line 116 of file SmartRef.h.

117 {
118 m_base.m_hintID = hint;
119 m_base.m_linkID = link;
120 m_target = obj;
121 _setEnvironment( 0, 0 );
122 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const ContainedObject * | pObj,
|  | long | hint,
|  | long | link,
|  | TYPE * | obj = `nullptr`
| ) |  |
| inline

Constructor for references to contained objects passing environment.

Definition at line 124 of file SmartRef.h.

125 {
126 m_base.m_hintID = hint;
127 m_base.m_linkID = link;
128 m_target = obj;
129 const DataObject* src = ( 0 == pObj ) ? 0 : pObj->parent();
130 _setEnvironment( src, pObj );
131 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
ContainedObject::parent
const ObjectContainerBase * parent() const
Access to parent object.
Definition: ContainedObject.h:52
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:29
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const DataObject * | pObj,
|  | long | hint,
|  | long | link,
|  | TYPE * | obj = `nullptr`
| ) |  |
| inline

Constructor for references to contained objects passing environment.

Definition at line 133 of file SmartRef.h.

134 {
135 m_base.m_hintID = hint;
136 m_base.m_linkID = link;
137 m_target = obj;
138 _setEnvironment( pObj, 0 );
139 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const DataObject * | pObj,
|  | long | hint,
|  | TYPE * | obj = `nullptr`
| ) |  |
| inline

Constructor for references to DataObjects passing environment.

Definition at line 141 of file SmartRef.h.

142 {
143 m_base.m_hintID = hint;
144 m_base.m_linkID = INVALID;
145 m_target = obj;
146 _setEnvironment( pObj, 0 );
147 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
SmartRef::INVALID
Definition: SmartRef.h:74

## Member Function Documentation

template<class TYPE>

const SmartRef<TYPE>& SmartRef< TYPE >::_setEnvironment | ( | const DataObject * | pObj,
|  | const ContainedObject * | pContd
| ) |  | const
| inline

Set the environment (CONST)

Definition at line 187 of file SmartRef.h.

188 {
189 m_base.m_data = pObj;
190 m_base.m_contd = pContd;
191 m_base.setObjectType( data() );
192 return *this;
193 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:55
SmartRefBase::setObjectType
void setObjectType(const ContainedObject *) const
Definition: SmartRefBase.h:103
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:57
SmartRef::data
TYPE * data()
Access to raw data pointer.
Definition: SmartRef.h:167
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::_setEnvironment | ( | const DataObject * | pObj,
|  | const ContainedObject * | pContd
| ) |  |
| inline

Set the environment (CONST)

Definition at line 195 of file SmartRef.h.

196 {
197 m_base.m_data = pObj;
198 m_base.m_contd = pContd;
199 m_base.setObjectType( data() );
200 return *this;
201 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:55
SmartRefBase::setObjectType
void setObjectType(const ContainedObject *) const
Definition: SmartRefBase.h:103
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:57
SmartRef::data
TYPE * data()
Access to raw data pointer.
Definition: SmartRef.h:167
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
template<class TYPE>

TYPE* SmartRef< TYPE >::data | ( |  | ) |
| inline

Access to raw data pointer.

Definition at line 167 of file SmartRef.h.

167 { return const_cast<TYPE*>( m_target ); }
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
template<class TYPE>

const TYPE* SmartRef< TYPE >::data | ( |  | ) | const
| inline

Definition at line 168 of file SmartRef.h.

168 { return m_target; }
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
template<class TYPE>

long SmartRef< TYPE >::hintID | ( |  | ) | const
| inline

Access hint id:

Definition at line 159 of file SmartRef.h.

159 { return m_base.m_hintID; }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
template<class TYPE>

long SmartRef< TYPE >::linkID | ( |  | ) | const
| inline

Access link id:

Definition at line 161 of file SmartRef.h.

161 { return m_base.m_linkID; }
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
template<class TYPE>

SmartRef< TYPE >::operator const TYPE * | ( |  | ) | const
| inline

Implicit type conversion to const object.

Definition at line 243 of file SmartRef.h.

243 { return SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:279
template<class TYPE>

SmartRef< TYPE >::operator TYPE * | ( |  | ) |
| inline

Implicit type conversion.

Definition at line 245 of file SmartRef.h.

245 { return SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:279
template<class TYPE>

bool SmartRef< TYPE >::operator!= | ( | const SmartRef< TYPE > & | c | ) | const
| inline

NON-Equality operator.

Definition at line 185 of file SmartRef.h.

185 { return !( this->operator==( c ) ); }
SmartRef::operator==
bool operator==(const SmartRef< TYPE > &c) const
Equality operator.
Definition: SmartRef.h:176
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::operator() | ( | ContainedObject * | pObj | ) |
| inline

operator(): assigns parent object for serialisation

Definition at line 203 of file SmartRef.h.

204 {
205 const DataObject* src = ( pObj ? pObj->parent() : nullptr );
206 return _setEnvironment( src, pObj );
207 }
ContainedObject::parent
const ObjectContainerBase * parent() const
Access to parent object.
Definition: ContainedObject.h:52
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:29
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
template<class TYPE>

const SmartRef<TYPE>& SmartRef< TYPE >::operator() | ( | const ContainedObject * | pObj | ) | const
| inline

operator() const: assigns parent object for serialisation

Definition at line 209 of file SmartRef.h.

210 {
211 const DataObject* src = ( pObj ? pObj->parent() : nullptr );
212 return _setEnvironment( src, pObj );
213 }
ContainedObject::parent
const ObjectContainerBase * parent() const
Access to parent object.
Definition: ContainedObject.h:52
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:29
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::operator() | ( | DataObject * | pObj | ) |
| inline

operator(): assigns parent object for serialisation

Definition at line 215 of file SmartRef.h.

215 { return _setEnvironment( pObj, nullptr ); }
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
template<class TYPE>

const SmartRef<TYPE>& SmartRef< TYPE >::operator() | ( | const DataObject * | pObj | ) | const
| inline

operator() const: assigns parent object for serialisation

Definition at line 217 of file SmartRef.h.

217 { return _setEnvironment( pObj, nullptr ); }
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
template<class TYPE>

TYPE& SmartRef< TYPE >::operator* | ( |  | ) |
| inline

Dereference operator.

Definition at line 235 of file SmartRef.h.

235 { return *SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:279
template<class TYPE>

const TYPE& SmartRef< TYPE >::operator* | ( |  | ) | const
| inline

Dereference operator.

Definition at line 237 of file SmartRef.h.

237 { return *SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:279
template<class TYPE>

TYPE* SmartRef< TYPE >::operator-> | ( |  | ) |
| inline

Dereference operator.

Definition at line 239 of file SmartRef.h.

239 { return SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:279
template<class TYPE>

const TYPE* SmartRef< TYPE >::operator-> | ( |  | ) | const
| inline

Dereference operator to const object.

Definition at line 241 of file SmartRef.h.

241 { return SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:279
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::operator= | ( | const SmartRef< TYPE > & | c | ) |
| inline

Assignment.

Definition at line 219 of file SmartRef.h.

220 {
221 m_target = c.m_target;
222 m_base.m_hintID = c.m_base.m_hintID;
223 m_base.m_linkID = c.m_base.m_linkID;
224 return _setEnvironment( c.m_base.m_data, c.m_base.m_contd );
225 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:55
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:57
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:187
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::operator= | ( | TYPE * | pObject | ) |
| inline

Assignment.

Definition at line 227 of file SmartRef.h.

228 {
229 m_target = pObject;
230 m_base.m_hintID = INVALID;
231 m_base.m_linkID = INVALID;
232 return *this;
233 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::INVALID
Definition: SmartRef.h:74
template<class TYPE>

bool SmartRef< TYPE >::operator== | ( | const SmartRef< TYPE > & | c | ) | const
| inline

Equality operator.

Definition at line 176 of file SmartRef.h.

177 {
178 if ( m_target && c.m_target ) return m_target == c.m_target;
179 if ( !m_target && !c.m_target ) return m_base.isEqual( m_target, c.m_base );
180 if ( m_target && !c.m_target ) return m_base.isEqualEx( m_target, c.m_base );
181 if ( !m_target && c.m_target ) return c.m_base.isEqualEx( c.m_target, m_base );
182 return false;
183 }
SmartRefBase::isEqual
bool isEqual(const ContainedObject *, const SmartRefBase &c) const
Equality operator for ContainedObject like references.
Definition: SmartRefBase.h:73
SmartRefBase::isEqualEx
bool isEqualEx(const DataObject *pObj, const SmartRefBase &c) const
Extended equality check.
Definition: SmartRefBase.cpp:72
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
template<class TYPE>

const std::string& SmartRef< TYPE >::path | ( |  | ) | const
| inline

Return the path of the linked object inside the data store.

Definition at line 174 of file SmartRef.h.

174 { return m_base.path(); }
SmartRefBase::path
const std::string & path() const
Shortcut to access the path to the linked object.
Definition: SmartRefBase.cpp:96
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
template<class TYPE >

StreamBuffer & SmartRef< TYPE >::readRef | ( | StreamBuffer & | s | ) |
| inline

Read the reference from the stream buffer (needed due to stupid G++ compiler)

Definition at line 297 of file SmartRef.h.

298 {
299 m_target = dynamic_cast<TYPE*>( m_base.readObject( m_target, s ) );
300 return s;
301 }
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
gaudirun.s
string s
Definition: gaudirun.py:253
SmartRefBase::readObject
DataObject * readObject(const DataObject *, StreamBuffer &s) const
Input streamer for DataObject like references.
Definition: SmartRefBase.h:90
template<class TYPE>

void SmartRef< TYPE >::set | ( | DataObject * | pObj,
|  | long | hint_id,
|  | long | link_id
| ) |  |
| inline

Setup smart reference when reading. Must be allowed from external sources.

Definition at line 163 of file SmartRef.h.

163 { m_base.set( pObj, hint_id, link_id ); }
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRefBase::set
void set(DataObject *pObj, long hint_id, long link_id)
Setup smart reference when reading. Must be allowed from external sources.
Definition: SmartRefBase.cpp:26
template<class TYPE>

bool SmartRef< TYPE >::shouldFollowLink | ( | const DataObject * |  | ) | const
| inline

Standard destructor.

Check if link should be followed: link must be valid and object not yet loaded

Definition at line 152 of file SmartRef.h.

152 { return ( !m_target && m_base.m_hintID != INVALID ); }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRef::INVALID
Definition: SmartRef.h:74
template<class TYPE>

bool SmartRef< TYPE >::shouldFollowLink | ( | const ContainedObject * |  | ) | const
| inline

Check if link should be followed: link must be valid and object not yet loaded.

Definition at line 154 of file SmartRef.h.

155 {
156 return ( !m_target && m_base.m_hintID != INVALID && m_base.m_linkID != INVALID );
157 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:51
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:53
SmartRef::INVALID
Definition: SmartRef.h:74
template<class TYPE >

const TYPE * SmartRef< TYPE >::target | ( |  | ) | const
| inline

Access to the object.

Access to the object (CONST)

Definition at line 279 of file SmartRef.h.

280 {
281 if ( !m_target ) {
282 m_target = dynamic_cast<const TYPE*>( m_base.accessData( m_target ) );
283 }
284 return m_target;
285 }
SmartRefBase::accessData
const ContainedObject * accessData(const ContainedObject *typ) const
Load on demand of ContainedObject like references.
Definition: SmartRefBase.cpp:34
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
template<class TYPE >

TYPE * SmartRef< TYPE >::target | ( |  | ) |
| inline

Access to the object.

Definition at line 269 of file SmartRef.h.

270 {
271 if ( !m_target ) {
272 m_target = dynamic_cast<const TYPE*>( m_base.accessData( m_target ) );
273 }
274 return const_cast<TYPE*>( m_target );
275 }
SmartRefBase::accessData
const ContainedObject * accessData(const ContainedObject *typ) const
Load on demand of ContainedObject like references.
Definition: SmartRefBase.cpp:34
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
template<class TYPE>

const std::type_info* SmartRef< TYPE >::type | ( |  | ) | const
| inline

Access to embedded type.

Definition at line 165 of file SmartRef.h.

165 { return &typeid( TYPE ); }
template<class TYPE >

StreamBuffer & SmartRef< TYPE >::writeRef | ( | StreamBuffer & | s | ) | const
| inline

Write the reference to the stream buffer (needed due to stupid G++ compiler)

Definition at line 289 of file SmartRef.h.

290 {
291 m_base.writeObject( m_target, s );
292 return s;
293 }
SmartRefBase::writeObject
void writeObject(const DataObject *pObject, StreamBuffer &s) const
Output streamer for DataObject like references.
Definition: SmartRefBase.h:83
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:79
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:81
gaudirun.s
string s
Definition: gaudirun.py:253

## Friends And Related Function Documentation

template<class TYPE>

StreamBuffer& operator<< | ( | StreamBuffer & | _s,
|  | const SmartRef< TYPE > & | ptr
| ) |  |
| friend

Output Streamer operator.

Definition at line 252 of file SmartRef.h.

252 { return ptr.writeRef( _s ); }
SmartRef::writeRef
StreamBuffer & writeRef(StreamBuffer &s) const
Write the reference to the stream buffer (needed due to stupid G++ compiler)
Definition: SmartRef.h:289
template<class TYPE>

StreamBuffer& operator>> | ( | StreamBuffer & | _s,
|  | SmartRef< TYPE > & | ptr
| ) |  |
| friend

Input Streamer operator.

Definition at line 255 of file SmartRef.h.

255 { return ptr.readRef( _s ); }
SmartRef::readRef
StreamBuffer & readRef(StreamBuffer &s)
Read the reference from the stream buffer (needed due to stupid G++ compiler)
Definition: SmartRef.h:297
template<class TYPE>

friend class SmartRefArray< TYPE >
| friend

The container must be a friend.

Definition at line 69 of file SmartRef.h.

template<class TYPE>

friend class SmartRefList< TYPE >
| friend

Definition at line 70 of file SmartRef.h.

template<class TYPE>

friend class SmartRefMap< TYPE >
| friend

Definition at line 71 of file SmartRef.h.

## Member Data Documentation

template<class TYPE>

SmartRefBase SmartRef< TYPE >::m_base
| protected

Definition at line 79 of file SmartRef.h.

template<class TYPE>

const TYPE* SmartRef< TYPE >::m_target = nullptr
| mutable protected

Pointer to target data object.

Definition at line 81 of file SmartRef.h.

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/SmartRef.h